sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) New Deal 1997 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555
CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55

REM useful text style constants
CONST UNDERLINE		1
CONST STRIKE_THRU	2
CONST SUBSCRIPT		4
CONST SUPERSCRIPT	8
CONST ITALIC		16
CONST BOLD		32

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5
CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7

CONST C_SYS_00			&Hff00
CONST C_SYS_FF			&Hffff
CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91

REM date formats
CONST DTF_LONG				0
CONST DTF_LONG_CONDENSED		1
CONST DTF_LONG_NO_WEEKDAY		2
CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3
CONST DTF_SHORT				4
CONST DTF_ZERO_PADDED_SHORT		5
CONST DTF_MD_LONG			6
CONST DTF_MD_LONG_NO_WEEKDAY		7
CONST DTF_MD_SHORT			8
CONST DTF_MY_LONG			9
CONST DTF_MY_SHORT			10
CONST DTF_YEAR				11
CONST DTF_MONTH				12
CONST DTF_DAY				13
CONST DTF_WEEKDAY			14
REM time formats
CONST DTF_HMS				15
CONST DTF_HM				16
CONST DTF_H				17
CONST DTF_MS				18
CONST DTF_HMS_24HOUR			19
CONST DTF_HM_24HOUR			20

REM pi
CONST PI 3.14159265359

REM Format() constants
CONST FFAF_SCIENTIFIC		&H100
CONST FFAF_PERCENT		&H80
CONST FFAF_USE_COMMAS		&H40
CONST FFAF_NO_TRAIL_ZEROS	&H20
CONST FFAF_NO_LEAD_ZERO		&H10

REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim form1 as form
form1 = MakeComponent("form","app")
CompInit form1
proto="form1"
top=115
left=94
sizeHControl=0
sizeVControl=0
caption="Bouncer 0.1.3 Multibounce lines - Fullscreen"
End CompInit
Dim button1 as button
button1 = MakeComponent("button",form1)
CompInit button1
proto="button1"
caption="Go!"
sizeHControl=0
sizeVControl=0
left=143
top=189
height=22
visible=1
End CompInit
button1.name="button1"
Dim label1 as label
label1 = MakeComponent("label",form1)
CompInit label1
proto="label1"
caption="start x coordinates"
sizeHControl=3
sizeVControl=3
left=4
top=9
visible=1
End CompInit
label1.name="label1"
Dim number1 as number
number1 = MakeComponent("number",form1)
CompInit number1
proto="number1"
value=280
maximum=1024
left=137
top=5
visible=1
End CompInit
number1.name="number1"
Dim label2 as label
label2 = MakeComponent("label",form1)
CompInit label2
proto="label2"
caption="start y coordinates"
sizeHControl=0
sizeVControl=0
left=3
top=46
height=17
visible=1
End CompInit
label2.name="label2"
Dim number2 as number
number2 = MakeComponent("number",form1)
CompInit number2
proto="number2"
caption=""
value=300
maximum=768
sizeHControl=3
sizeVControl=3
left=136
top=43
visible=1
End CompInit
number2.name="number2"
Dim button2 as button
button2 = MakeComponent("button",form1)
CompInit button2
proto="button2"
caption="About"
sizeHControl=0
sizeVControl=0
left=267
top=189
height=22
visible=1
End CompInit
button2.name="button2"
Dim label4 as label
label4 = MakeComponent("label",form1)
CompInit label4
proto="label4"
caption="value w"
left=3
top=82
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label4.name="label4"
Dim number3 as number
number3 = MakeComponent("number",form1)
CompInit number3
proto="number3"
left=136
top=79
sizeHControl=0
sizeVControl=0
width=52
value=2
maximum=150
height=20
visible=1
End CompInit
number3.name="number3"
Dim label5 as label
label5 = MakeComponent("label",form1)
CompInit label5
proto="label5"
caption="value v"
left=1
top=117
sizeHControl=3
sizeVControl=0
height=14
visible=1
End CompInit
label5.name="label5"
Dim number4 as number
number4 = MakeComponent("number",form1)
CompInit number4
proto="number4"
left=134
top=114
sizeHControl=0
sizeVControl=0
width=45
value=3
maximum=200
visible=1
End CompInit
number4.name="number4"
Dim toggle1 as toggle
toggle1 = MakeComponent("toggle",form1)
CompInit toggle1
proto="toggle1"
caption="red"
left=7
top=150
sizeHControl=3
sizeVControl=3
status=1
visible=1
End CompInit
toggle1.name="toggle1"
Dim toggle2 as toggle
toggle2 = MakeComponent("toggle",form1)
CompInit toggle2
proto="toggle2"
caption="green"
left=7
top=174
sizeHControl=0
sizeVControl=0
height=23
visible=1
End CompInit
toggle2.name="toggle2"
Dim toggle3 as toggle
toggle3 = MakeComponent("toggle",form1)
CompInit toggle3
proto="toggle3"
caption="blue"
left=7
top=197
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
toggle3.name="toggle3"
Dim text2 as text
text2 = MakeComponent("text",form1)
CompInit text2
proto="text2"
left=229
top=6
height=160
End CompInit
text2.name="text2"
text2.AppendString("This is a preliminary test... please do not select more then one color as it still results in weirdo thing :-)\r")
text2.AppendString("\r")
text2.AppendString("to exit just klick with the mouse...\r")
text2.AppendString("\r")
text2.AppendString("hope you like it :-)\r")
text2.AppendString("\r")
text2.AppendString("dvocat@datanetworks.ch")
text2.visible=1
form1.width=460
form1.height=260
form1.name="form1"
Dim dialog1 as dialog
dialog1 = MakeComponent("dialog","app")
CompInit dialog1
proto="dialog1"
left=621
top=239
tile=1
tileLayout=1
End CompInit
Dim picture1 as picture
picture1 = MakeComponent("picture",dialog1)
CompInit picture1
proto="picture1"
width=78
height=78
visible=1
End CompInit
picture1.name="picture1"
picture1.graphic=GetComplex(0)
Dim picture2 as picture
picture2 = MakeComponent("picture",dialog1)
CompInit picture2
proto="picture2"
width=78
height=78
visible=1
End CompInit
picture2.name="picture2"
picture2.graphic=GetComplex(1)
Dim picture3 as picture
picture3 = MakeComponent("picture",dialog1)
CompInit picture3
proto="picture3"
height=78
width=78
visible=1
End CompInit
picture3.graphic=GetComplex(2)
picture3.name="picture3"
Dim picture4 as picture
picture4 = MakeComponent("picture",dialog1)
CompInit picture4
proto="picture4"
width=78
height=78
visible=1
End CompInit
picture4.graphic=GetComplex(3)
picture4.name="picture4"
dialog1.name="dialog1"
dialog1.width=280
dialog1.height=140
Dim dialog2 as dialog
dialog2 = MakeComponent("dialog","app")
CompInit dialog2
proto="dialog2"
left=669
top=14
tile=1
caption="About"
End CompInit
Dim text1 as text
text1 = MakeComponent("text",dialog2)
CompInit text1
proto="text1"
height=160
End CompInit
text1.name="text1"
text1.AppendString("Ok so this my first pitifull public testlet :-)\r")
text1.AppendString("Hope you don't mind the smear behind the Ball :-)\r")
text1.AppendString("\r")
text1.AppendString("Dominique Vocat\r")
text1.AppendString("dvocat@datanetworks.ch\r")
text1.AppendString("\r")
text1.AppendString("Oh, and please post your NewBasic things including the source because whe all want to learn from each other don't whe?")
text1.visible=1
Dim button3 as button
button3 = MakeComponent("button",dialog2)
CompInit button3
proto="button3"
caption="Aaargh! Enough already!"
sizeHControl=3
closeDialog=1
sizeVControl=3
visible=1
End CompInit
button3.name="button3"
dialog2.name="dialog2"
dialog2.width=280
dialog2.height=220
Dim display1 as display
display1 = MakeComponent("display","app")
CompInit display1
proto="display1"
End CompInit
display1.name="display1"
Dim floater1 as floater
floater1 = MakeComponent("floater","app")
CompInit floater1
proto="floater1"
left=0
top=0
width=51
height=84
End CompInit
Dim gadget1 as gadget
gadget1 = MakeComponent("gadget",floater1)
CompInit gadget1
proto="gadget1"
width=800
height=600
left=0
top=0
visible=1
End CompInit
gadget1.name="gadget1"
floater1.caption="floater1"
floater1.name="floater1"
EnableEvents()
duplo_start()
end sub

sub duplo_start()
REM place initialization code here

REM ***************************************************************************
REM * I know it is ugly spaghetti code but hey, at least it does something... *
REM ***************************************************************************

dialog2.visisble = 0
floater1.visible = 0

DIM animcount AS integer
DIM status1 AS integer
DIM status2 AS integer
animcount = 0
status1 = -1
status2 = -1

DIM i1 AS integer
DIM x1 AS integer
DIM y1 AS integer
DIM v1 AS integer
DIM w1 AS integer
DIM i2 AS integer
DIM x2 AS integer
DIM y2 AS integer
DIM v2 AS integer
DIM w2 AS integer


x1 = number1.value
y1 = number2.value
v1 = number3.value
w1 = number4.value
x2 = number1.value
y2 = number2.value
v2 = number3.value
w2 = number4.value

number1.maximum = display1.width
number2.maximum = display1.height

end sub

sub module_goTo(context as string)

end sub

function module_getContext()

module_getContext = ""

end function

sub module_show()
REM code for making this module appear
form1.visible=1

end sub

sub module_hide()
REM code for making this module disappear
form1.visible=0

end sub

sub module_exit()

end sub

sub button1_pressed(self as button)

floater1.height = display1.height
floater1.width = display1.width
gadget1.height = display1.height
gadget1.width = display1.width

floater1.visible = 1

status1 = status1 + 1

pinsel()

IF status1 = 0 THEN
	gadget1.DrawRect( 0, 0, 800, 600, BLACK)
ELSE
	gadget1.DrawRect( 0, 0, 800, 600, BLACK)
	status1 = -1	
END IF

end sub

sub pinsel()

x1 = number1.value
y1 = number2.value
x2 = number1.value + 50
y2 = number2.value - 37

DIM color1 AS long
DIM colorCalcTMP AS integer
DIM r AS integer
DIM kipper AS integer

DIM SevenByte	AS LONG
DIM FiveByte	AS LONG
DIM ThreeByte	AS LONG

DIM red		AS INTEGER
DIM blue		AS INTEGER
DIM green		AS INTEGER
DIM opac		AS LONG

SevenByte	= &H1000000
FiveByte	= &H10000
ThreeByte	= &H100

red = 3
blue = 3
green = 3
opac = &HFF

kipper = 1
r = 1

REM set the stage...
gadget1.DrawRect( 0, 0, gadget1.height, gadget1.width, BLACK)

DO WHILE status1 = 0

IF toggle1.status = 1 THEN
	IF red >= 3 AND red <= 252 THEN
		red = red + kipper
	ELSE
		kipper = kipper * -1
		red = red + kipper
	END IF
END IF

IF toggle2.status = 1 THEN
	IF green >= 3 AND green <= 252 THEN
		green = green + kipper
	ELSE
		kipper = kipper * -1
		green = green + kipper
	END IF
END IF

IF toggle3.status = 1 THEN
	IF blue >= 3 AND blue <= 252 THEN
		blue = blue + kipper
	ELSE
		kipper = kipper * -1
		blue = blue + kipper
	END IF
END IF

color1 = (opac * SevenByte) + (red * FiveByte) + (green * ThreeByte) + blue

	IF x1 >= 9 AND x1 <= (gadget1.width - 9) THEN
		REM this should, if activated, cause that you only see the ball fly around but it smears somewhat
		'gadget1.DrawImage(picture1.graphic, x, y)
		x1 = x1+v1
		y1 = y1+w1
		gadget1.DrawLine( x1, y1, x2, y2, color1)
	ELSE
		v1 = v1*-1
		'gadget1.DrawImage(picture1.graphic, x, y)
		x1 = x1+v1
		y1 = y1+w1
		gadget1.DrawLine( x1, y1, x2, y2, color1)
	END IF
	IF y1 >= 9 AND y1 <= (gadget1.height - 9) THEN
		'gadget1.DrawImage(picture1.graphic, x, y)
		x1 = x1+v1
		y1 = y1+w1
		gadget1.DrawLine( x1, y1, x2, y2, color1)
	ELSE
		w1 = w1*-1
		'gadget1.DrawImage(picture1.graphic, x, y)
		x1 = x1+v1
		y1 = y1+w1
		gadget1.DrawLine( x1, y1, x2, y2, color1)
	END IF

	IF x2 >= 9 AND x2 <= (gadget1.width - 9) THEN
		REM this should, if activated, cause that you only see the ball fly around but it smears somewhat
		'gadget1.DrawImage(picture1.graphic, x, y)
		x2 = x2+v2
		y2 = y2+w2
		gadget1.DrawLine( x1, y1, x2, y2, color1)
	ELSE
		v2 = v2*-1
		'gadget1.DrawImage(picture1.graphic, x, y)
		x2 = x2+v2
		y2 = y2+w2
		gadget1.DrawLine( x1, y1, x2, y2, color1)
	END IF
	IF y2 >= 9 AND y2 <= (gadget1.height - 9) THEN
		'gadget1.DrawImage(picture1.graphic, x, y)
		x2 = x2+v2
		y2 = y2+w2
		gadget1.DrawLine( x1, y1, x2, y2, color1)
	ELSE
		w2 = w2*-1
		'gadget1.DrawImage(picture1.graphic, x, y)
		x2 = x2+v2
		y2 = y2+w2
		gadget1.DrawLine( x1, y1, x2, y2, color1)
	END IF

LOOP

end sub

sub button2_pressed(self as button)

dialog2.visible = 1

end sub

sub gadget1_mouse(self as gadget, action as integer, flag as integer, X as integer, Y as integer, modifier as integer)

IF action = 1 THEN
'	number1.value = X
'	number2.value = Y
floater1.visible = 0
END IF

end sub

sub gadget1_draw(self as gadget)

self.DrawRect( 0, 0, gadget1.width, gadget1.height, BLACK)
'self.DrawText( "Bouncer version 0.1.1 ... enjoy !", 10, 10, BLACK, "URW Roman", 12, 0)

end sub

